/******************************************************

*******************************************************/
#include <16f877A.h>    
// microcontroller fuse settings
#fuses XT,NOWDT,NOPROTECT,NOBROWNOUT,NOLVP,NOPUT,NOWRT,NODEBUG,NOCPD

#use delay (clock=4000000) // our crystal is 4000000Hz
#use rs232 (baud=2400, xmit=pin_C6, rcv=pin_C7,enable=pin_d0,bits=9, parity=N,stop=1)
#use fast_io(c) //fast use of port-c
#use fast_io(e) //fast use of port-e
#use fast_io(d) //fast use of port-d
#define use_portb_lcd TRUE   // lcd is connected to the port b
#include <lcd.c>   // calling the lcd.c file
#define s15 pin_a0 // to measure the heartbeat 15 seconds
#define s30 pin_a1 // to measure the heartbeat 30 seconds
#define s45 pin_a2 // to measure the heartbeat 45 seconds
#define s60 pin_a3 // to measure the heartbeat 60 seconds
#define sent pin_a5 // sent pin to pc
int1 modchose=0;
int counted=0;
int1 test=0; // continue check
float multiply=0;
int16 h_rate=0;  // to show the heart beat of the patient
int16 threshold=15000; // threshold time to measure the heart beat then process the outputs.
int32 time=0,counter=0;
#int_timer0 // Timer0 interrupts
void  timer0_kesme ()   //the name of the interrupts function
{
set_timer0(60); // to create 50ms interrupts
time=time+50; // counting how much time past
}
void send()
{
   printf(lcd_putc,"\f sending.");
   delay_ms(600);
   printf(lcd_putc,"\f sending..");
   delay_ms(600);
   printf(lcd_putc,"\f sending...");
   delay_ms(600);
   printf(lcd_putc,"\f sending.");
   delay_ms(600);
   printf(lcd_putc,"\f sending..");
   delay_ms(600);
   printf(lcd_putc,"\f sending...");
   delay_ms(600);
   delay_ms(600);
   printf(lcd_putc,"\f sending.");
   delay_ms(600);
   printf(lcd_putc,"\f sending..");
   delay_ms(600);
   printf(lcd_putc,"\f sending...");
   delay_ms(600);
putc(h_rate);
output_high(pin_d1);
delay_ms(600);
output_low(pin_d1);

}
//********** main function*******

void main ( )
{
   setup_psp(PSP_DISABLED);        // PSP unit wont be used
   setup_timer_1(T1_DISABLED);     // T1 timer wont be used
   setup_timer_2(T2_DISABLED,0,1); // T2 timer wont be used
   setup_CCP1(CCP_OFF);            // CCP1 unit wont be used
   setup_CCP2(CCP_OFF);            // CCP2 unit wont be used
   setup_timer_0(RTCC_INTERNAL | RTCC_DIV_256); // Timer0 settings
   set_timer0(60);   // TMR0 value
   enable_interrupts(INT_timer0); // int_timer0 interrupts is allowed
   enable_interrupts(GLOBAL);     // all interrupts is allowed
   set_tris_a(0xff);
   set_tris_c(0x00);  // C port is output
   set_tris_d(0x00);
   set_tris_e(0b111);
   output_a(0xFF); // set port a as input
   output_c(0x00);    // reset c-port
   output_d(0x00);// reset e-port
   output_e(0b000);
   output_high(pin_d0);delay_ms(150); 
   output_low(pin_d0);delay_ms(150);
   lcd_init(); 
   printf(lcd_putc,"\fHeart Beat");
   lcd_gotoxy(1,2);
   printf(lcd_putc,"Measuring");
   delay_ms(1000);
   printf(lcd_putc,"\fChoose a mod to");
   lcd_gotoxy(1,2);
   printf(lcd_putc,"measure");
   delay_ms(1000);
  while(true)
  {
///////////////////////////////////////////// pin_a0
 if(!input(s15))
 {
 while (!input(s15));
 test=1;
 counter=0;
 time=0;
 threshold =15000;
 modchose=1;
 multiply=4;
 enable_interrupts(INT_timer0); // int_timer0 interrupts is allowed
 }
/////////////////////////////////////////// pin_a1
if(!input(s30))
 {
 while (!input(s30));
 test=1;
 counter=0;
 time=0;
 threshold =30000;
 modchose=1;
 multiply=2;
 enable_interrupts(INT_timer0); // int_timer0 interrupts is allowed
 }
/////////////////////////////////////////// pin_a2
if(!input(s45))
 {
 while (!input(s45));
 test=1;
 counter=0;
 time=0;
 threshold =45000;
 modchose=1;
 multiply=1.33;
 enable_interrupts(INT_timer0); // int_timer0 interrupts is allowed
 } 
/////////////////////////////////////////// pin_a3
if(!input(s60))
 {
 while (!input(s60));
 test=1;
 counter=0;
 time=0;
 threshold =60000;
 modchose=1;
 multiply=1;
 enable_interrupts(INT_timer0); // int_timer0 interrupts is allowed
 }
//////////////////////////////////////////////
/*            Sent to computer         */
if(!input(pin_a5))
{
while(!input(pin_a5));
if(test==1)
send();
else
{
printf(lcd_putc,"\f Nothing is");
lcd_gotoxy(1,2);
printf(lcd_putc,"measured !");
delay_ms(1000);
}
}
//////////////////////////////////////////////////
/*      Start to count             */
if(modchose==1)
{
 if(test==1)
 {
 if(input(pin_e0))
 {
  while(input(pin_e0));
  if(counted==0)
  {
 counter++;
 counted=1;
  }
  }
  printf(lcd_putc,"\ftime %li",time); 
  lcd_gotoxy(1,2);
  printf(lcd_putc,"the rate is %li",counter);
  delay_ms(10);
  counted=0;
  }
}
////////////////////////////////////////////////////////
/*        Show the result     */
  if(time>=threshold)
  {
  test=0; // stop counting
  h_rate=multiply*counter;//  get the counted value
  disable_interrupts(int_timer0);
  printf(lcd_putc,"\fYour Heart");
  lcd_gotoxy(1,2);
  printf(lcd_putc,"\bpm is: %li",h_rate);
  delay_ms(1300);
  }
  
  }
}
